using System.Collections.ObjectModel;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ObservableCollection<string> collection = new ObservableCollection<string>();

        for(int i = 1; i < 100; i++)
        {
            collection.Add($"׸ {i}");
        }

        this.itemsRepeater.ItemsSource = collection;

        this.getItemButton.Click      += getItemButton_Click;
        this.getItemIndexButton.Click += getItemIndexButton_Click;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ׸ ϱ ư Ŭ óϱ - getItemButton_Click(sender, e)

    /// <summary>
    /// ׸ ϱ ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void getItemButton_Click(object sender, RoutedEventArgs e)
    {
        TextBlock itemTextBlock = this.itemsRepeater.GetOrCreateElement(3) as TextBlock;

        this.messageTextBlock.Text = itemTextBlock.Text;
    }

    #endregion
    #region ׸ ε ϱ ư Ŭ óϱ - getItemIndexButton_Click(sender, e)

    /// <summary>
    /// ׸ ε ϱ ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void getItemIndexButton_Click(object sender, RoutedEventArgs e)
    {
        TextBlock itemTextBlock = this.itemsRepeater.GetOrCreateElement(5) as TextBlock;

        int index = this.itemsRepeater.GetElementIndex(itemTextBlock);

        this.messageTextBlock.Text = $"׸ ε : {index}";
    }

    #endregion
}